/*********************************************
This program was produced by the
CodeWizardAVR V1.24.0 Standard
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : PPE robot suiveur de ligne
	  Commande d'un servo-moteur  (fichier prof)
Version : 1
Date    : 28/04/2008
Fichier : servo.c 
Author  : Philippe Mariano               
Company : LYCEE Pierre Emile MARTIN       
Comments: Le rapport cyclique du signal OC0A
est modifi en fonction de l'tat logique de PB3
PB3 = 0 => alpha = 0,110 (angle 0 pour le servo utilis) 
PB3 = 1 => alpha = 0,147 (angle +90 pour le servo utilis) 
Priode de OC0A = 13,6ms (9,6.10E6 /(510*256))^-1

Chip type           : ATtiny13
Clock frequency     : 9,600000 MHz
Memory model        : Tiny
External SRAM size  : 0
Data Stack size     : 16
*********************************************/

#include <tiny13.h>
#include <delay.h>

#define BRAS		OCR0A
#define SORT     	27             //  complter
#define RENTRE   	45             //  complter
#define Signal_du_R 	PINB.3
#define Signal_vers_R	PORTB.3

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
CLKPR=0x80;
CLKPR=0x00;

// Input/Output Ports initialization
// Port B initialization
// Func0=Out Func1=In Func2=In Func3=In Func4=In Func5=In 
// State0=1 State1=T State2=T State3=P State4=T State5=T 
PORTB=0x08;
DDRB=0x01;    				// A complter

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 37,500 kHz
// Mode: Phase correct PWM top=FFh
// OC0A output: Non-Inverted PWM
// OC0B output: Disconnected
TCCR0A=0x81;
TCCR0B=0x04;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

        
while (1)
      { 
      // Les bras est dans l'axe du robot pendant le dplacement
      // PB3 est initialement configure en entre 
     	while (Signal_du_R == 1) BRAS = RENTRE;  // On attend l'arrt du robot
      
      // Rotation du bras
	BRAS = SORT;	
 	delay_ms(2500); // On laisse le temps au bras de sortir
 		
      // E_S est configure en sortie
  	PORTB.3 = 1;    // PB3 en sortie
        DDRB.3 = 1; 
        delay_ms(10);   
        
      // Le bras prvient le robot qu'il est en position
        Signal_vers_R = 0;	// Le robot est inform que la balle est pose
        delay_ms(10);         
        
      // E_S est configur en entre
        PORTB.3 = 1;   //PB3 en entre
        DDRB.3 = 0; 
      };
}
